<template>
  <BaseModal title="Contact Detail" @close="close" @back="back" backEnabled >
    <template v-slot:content>
        <div class="content">
            <form>
              <div class="form-group mb-4" v-if="contact.contactName">
                <label for="contactName" class="mb-0">Contact Name</label>
                <h2 class="f-18 detail-value">{{contact.contactName}}</h2>
              </div>
              <div class="form-group mb-4">
                <label for="company" class="mb-0">Company</label>
                <h2 class="f-18 detail-value">{{contact.company}}</h2>
              </div>
              <div class="form-group mb-4">
                <label for="address" class="mb-0">Address</label>
                <input
                  type="text"
                  class="f-18 detail-address text-info d-inline-block border-0 p-0 address-display"
                  id="address"
                  v-on:click.prevent="copyWalletAddress($event)"
                  data-toggle="tooltip"
                  data-placement="bottom"
                  readonly
                  v-bind:value="contact.address"
                />
              </div>
            </form>
        </div>
    </template>
    <template v-slot:footer>
        <div class="options-footer">
            <div class="col-8 pl-0">
                <button
                type="button"
                data-dismiss="modal"
                class="btn btn-link-regular"
                v-on:click.prevent="openEditContact()"
                >Edit Contact</button>
            </div>
            <div class="col-16 pr-0">
                <button
                type="button"
                v-on:click.prevent="transferAmountTo(contact.address)"
                class="btn btn-send btn-send-main f-18"
                :disabled="userModule.userDetails.userBalanceInMinorUnit === '0.00'"
                >Send Payment</button>
            </div>
        </div>
    </template>
  </BaseModal>
</template>

<script lang="ts">
import { Prop, Component } from "vue-property-decorator";
import { mixins } from "vue-class-component";

import displayMessages from "@/constants/displayMessages";
import { loggerMessage } from "@/constants/logger";
import CopyToClipboard from "@/mixins/CopyToClipboard";
import ContactsModalUtils from "@/mixins/ContactsModalUtils";
import ContactsListModal from "@/components/buildings/ContactsListModal.vue";
import ContactEditModal from "@/components/buildings/ContactEditModal.vue";
import Contact from "@/models/Contact";

@Component
export default class ContactDetailModal extends mixins(
  CopyToClipboard,
  ContactsModalUtils
) {
  @Prop({
    default: {
      contactName: undefined,
      company: "",
      address: ""
    }
  })
  public readonly contact!: Contact;

  public copyWalletAddress(event: MouseEvent) {
    this.copyToClipboard(
      event.target,
      displayMessages.PUBLIC_ADDRESS_COPIED,
      loggerMessage.PUBLIC_ADDRESS_COPIED,
      loggerMessage.PUBLIC_ADDRESS_COPYING_FAILED
    );
  }

  public back() {
    this.modalModule.openOrReplaceModal({ modal: ContactsListModal, attr: {} });
  }

  public openEditContact() {
    this.modalModule.openOrReplaceModal({
      modal: ContactEditModal,
      attr: { contact: this.contact }
    });
  }
}
</script>

<style lang="scss" scoped>
.content {
    padding: 1rem;
    width: 100%;
}

.options-footer {
    display: flex;
    align-items: center;
}

.address-display {
  cursor: pointer;
}

.detail-value {
  color: #969696;
}

.detail-address {
  width: 100%;
  overflow: hidden;
  text-overflow: ellipsis;
}
</style>
